//ModifierUnStyle_302f.js
// 10.12.08 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Sert  modifier un style de paragraphe et/ou de caractre 
//selon un modle

if (app.documents.length == 0) {
	alert ("Il n'y a pas de document ouvert.", "Attention");
	exit();
}

// tester la slection
try {
	var curType = app.selection[0].constructor.name;
	if (curType != "InsertionPoint" && curType != "Character" && curType != "Text" && curType != "Word" 
		&& curType != "Line" && curType != "Paragraph" && curType != "TextColumn" && curType != "TextStyleRange") {
		alert ("Il faut slectionner un peu de texte.", "Attention");
		exit ();
	}
}
catch (e) {
	alert ("Il n'y a pas de slection.", "Attention");
	exit();
}

// vrifier, s'il y a des groupes de styles de paragraphes
paraGroups = app.documents[0].paragraphStyleGroups;
var nPSG = paraGroups.length;

// vrifier, s'il y a des groupes de styles de caractres
charGroups = app.documents[0].characterStyleGroups;
var nCSG = charGroups.length;

//--- dresser la liste des styles de paragraphes ---//
if (nPSG == 0) {
	var dlogPStyles = app.documents[0].paragraphStyles.everyItem().name;
	// remplacer le contenu du premier lment par un lment vide
	dlogPStyles[0] = "";
	nDlogPStyles = dlogPStyles.length;
}
else {
	pGroupNames = paraGroups.everyItem().name;
	pGroupNames = ["[Root]"].concat(pGroupNames);
	var curName;
	var dlogPStyles = app.documents[0].paragraphStyles.everyItem().name;
	// insrer trois espaces devant chaque nom
	for (var i=0; i<dlogPStyles.length; i++) {
		curName = "   " + dlogPStyles[i];
		dlogPStyles[i] = curName;
	}
	// remplacer le premier lment par "[Root]"
	dlogPStyles[0] = "[Root]";
	// insrer un lment vide au dbut
	dlogPStyles = [""].concat(dlogPStyles);
	var curGroup;
	var curParaStyles;
	// une boucle  travers les groupes
	for (var i=0; i<nPSG; i++) {
		curGroup = paraGroups[i];
		curParaStyles = curGroup.paragraphStyles.everyItem().name;
		// insrer trois espaces devant chaque nom
		for (var k=0; k<curParaStyles.length; k++) {
			curName = "   " + curParaStyles[k];
			curParaStyles[k] = curName;
		}
		// insrer un lment avec le nom du groupe
		curParaStyles = [curGroup.name].concat(curParaStyles);
		dlogPStyles = dlogPStyles.concat(curParaStyles);
	}
	nDlogPStyles = dlogPStyles.length;
	// mmoriser les positions des noms des groupes
	var pGroupIDs = new Array ();
	pGroupIDs.push(0);
	for (var i=2; i<nDlogPStyles; i++) {
		if (dlogPStyles[i][0] != " ") {
			pGroupIDs.push(i);
		}
	}
	// inverser l'ordre de la liste
	pGroupIDs.reverse();
}

//--- dresser la liste des styles de caractres ---//
if (nCSG == 0) {
	var dlogCStyles = app.documents[0].characterStyles.everyItem().name;
	// remplacer le contenu du premier lment par un lment vide
	dlogCStyles[0] = "";
		nDlogCStyles = dlogCStyles.length;
}
else {
	cGroupNames = charGroups.everyItem().name;
	cGroupNames = ["[Root]"].concat(cGroupNames);
	var dlogCStyles = app.documents[0].characterStyles.everyItem().name;
	// insrer trois espaces devant chaque nom
	for (var i=0; i<dlogCStyles.length; i++) {
		curName = "   " + dlogCStyles[i];
		dlogCStyles[i] = curName;
	}
	// remplacer le premier lment par "[Root]"
	dlogCStyles[0] = "[Root]";
	// insrer un lment vide au dbut
	dlogCStyles = [""].concat(dlogCStyles);
	// une boucle  travers les groupes
	var curGroup;
	var curCharStyles;
	for (var i=0; i<nCSG; i++) {
		curGroup = charGroups[i];
		curCharStyles = curGroup.characterStyles.everyItem().name;
		// insrer trois espaces devant chaque nom
		for (var k=0; k<curCharStyles.length; k++) {
			curName = "   " + curCharStyles[k];
			curCharStyles[k] = curName;
		}
		// insrer un lment avec le nom du groupe
		curCharStyles = [curGroup.name].concat(curCharStyles);
		dlogCStyles = dlogCStyles.concat(curCharStyles);
	}
	nDlogCStyles = dlogCStyles.length;
	// mmoriser les positions des noms des groupes
	var cGroupIDs = new Array ();
	cGroupIDs.push(0);
	for (var i=2; i<nDlogCStyles; i++) {
		if (dlogCStyles[i][0] != " ") {
			cGroupIDs.push(i);
		}
	}
	// inverser l'ordre de la liste
	cGroupIDs.reverse();
}

// effacer des dialogues qui sont ventuellement rests dans la mmoire
try {
	app.dialogs.everyItem().destroy();
}
catch (e) {
}

// activer l'affichage des dialogues (mesure prventive)
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// crer un dialogue
var aDialog = app.dialogs.add({name:"Slectionner le style  modifier", canCancel:true});
with (aDialog) {
	with (dialogColumns.add()) {
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Style de paragraphes:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var paraName = dropdowns.add({stringList:dlogPStyles, selectedIndex:0, minWidth:180});
			}
		}
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Style de caractres:"});
			staticTexts.add({staticLabel:" "});
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				var charName = dropdowns.add({stringList:dlogCStyles, selectedIndex:0, minWidth:180});
			}
		}
	}
	with (dialogColumns.add()) {
		staticTexts.add({staticLabel:"", minWidth:4});
	}
}
// montrer le dialogue
if (aDialog.show() == true) {
	// reprendre les choix de l'utilisateur
	paraID = paraName.selectedIndex;
	charID = charName.selectedIndex;
	// effacer le dialogue de la mmoire
	aDialog.destroy();
}
else {
	aDialog.destroy();
	exit();
}

// tester le choix de l'utilisateur
if (nPSG != 0) {
	if (paraID != 0) {
		var testString = dlogPStyles[paraID].slice(0,3);
		if (testString != "   ") {
			alert ("Il ne faut pas slectionner le nom d'un groupe!", "Stop");
			exit();
		}
	}
}
if (nCSG != 0) {
	if (charID != 0) {
		var testString = dlogCStyles[charID].slice(0,3);
		if (testString != "   ") {
			alert ("Il ne faut pas slectionner le nom d'un groupe!", "Stop");
			exit();
		}
	}
}

// relever les attributs de la slection
var newProps = app.selection[0].properties;

// modifier le(s) style(s) correspondant(s)
if (paraID != 0) {
	// mmoriser le nom du style
	var curPara = dlogPStyles[paraID];
	// s'il n'y a pas de groupes de styles...
	if (nPSG == 0) {
		app.documents[0].paragraphStyles.item(curPara).properties = newProps;
	}
	// ... sinon, il faut obtenir le nom du groupe
	else {
		grpName = undefined;
		// supprimer les trois espaces
		curPara = curPara.slice(3);
		// inverser la liste des noms des groupes
		pGroupNames.reverse();
		// une boucle  travers la liste
		for (var s=0; s<pGroupIDs.length; s++) {
			// reprendre le nom du grpupe lorsque la position du groupe 
			// est plus petite que celle du style
			if (pGroupIDs[s]<paraID) {
				grpName = pGroupNames[s];
				break;
			}
		}
		if (grpName != undefined) {
			// la rfrence avec 'paragraphStyleGroups' n'est pas valable pour "[Root]"
			if (grpName != "[Root]") {
				var curGroup = app.documents[0].paragraphStyleGroups.item(grpName);
				var curPara = curGroup.paragraphStyles.item(curPara).properties = newProps;
			}
			else {
				app.documents[0].paragraphStyles.item(curPara).properties = newProps;
			}
		}
	}
}
// la mme procdure avec un style de caractres slectionn
if (charID != 0) {
	var curChar = dlogCStyles[charID];
	if (nCSG == 0) {
		app.documents[0].characterStyles.item(curChar).properties = newProps;
	}
	else {
		grpName = undefined;
		curChar = curChar.slice(3);
		cGroupNames.reverse();
		for (var s=0; s<cGroupIDs.length; s++) {
			if (cGroupIDs[s]<charID) {
				grpName = cGroupNames[s];
				break;
			}
		}
		if (grpName != undefined) {
			if (grpName != "[Root]") {
				var curGroup = app.documents[0].characterStyleGroups.item(grpName);
				var curPara = curGroup.characterStyles.item(curChar).properties = newProps;
			}
			else {
				app.documents[0].characterStyles.item(curChar).properties = newProps;
			}
		}
	}
}